﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GcDevicePc.Common
{
    class TWFile
    {
        private string filename = "default.hw";
        private FileStream twfsopen;
        public BinaryWriter bw;

        private String head = "HW Data Fi03\n";
        private byte[] headdata;

        private byte[] enddata = new byte[] 
        { 
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x1E,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x40,0x0D,0x03,0x00,0x01,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x62,0xC5,0xF2,0x59,
            0x05,0x00,0x00,0x00,0x64,0x00,0x00,0x00,0x21,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x1A,0x4F,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x80,0x3F,0x00,0x00,0x80,0x3F,
            0x00,0x00,0x80,0x3F,0x00,0x00,0x80,0x3F,0x00,0x00,0xE0,0x74,0xFE,0x02,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x86,0x32,0x31,0x33,0x3A,0x33,0x36,0x36,0x36,0x3A,
            0x40,0x2A,0x3C,0x3F,0x47,0x41,0x43,0x4A,0x43,0x48,0x1C,0x87,0x89,0x77,0x89,0x8C,
            0x7E,0x7E,0x3B,0x7D,0x80,0x8F,0x94,0x89,0x94,0x8B,0x97,0x8D,0x94,0x94,0x47,0x9F,
            0x92,0x9E,0x93,0x4C,0xA0,0x93,0xA1,0x99,0x92,0x9E,0x53,0xA2,0xAA,0xA3,0x99,0x9D,
            0xAB,0x5A,0x6B,0x6C,0x6D,0x6E,0x6F,0x71,0x4B,0x74,0x73,0x75,0x7C,0x75,0x78,0x78,
            0x78,0x7C,0x82,0x6C,0x7E,0x81,0x89,0x83,0x85,0x8C,0x85,0x8A,0x5E,0xC8,0xBC,0xC1,
            0xC0,0xC3,0xCE,0xC5,0xD1,0xC3,0xC3,0x80,0xC3,0xDB,0x83,0xD8,0xCA,0xD3,0xD7,0xD7,
            0xDB,0xCB,0xDD,0xE5,0x95,0x97,0x9B,0x90,0xE4,0xEB,0xE6,0xE8,0xDA,0xE3,0x97,0xD9,
            0xDD,0xE7,0xE4,0xEA,0xE6,0xF1,0xF3,0xF2,0xE2,0xF6,0xF2,0xF6,0x8F,0x00,0x00,0x00,
            0x00
        };

        public TWFile(string file)
        {
            this.filename =  file;
            if (File.Exists(filename))
            {
                File.Delete(filename);
            }
            FileStream twfs = new FileStream(filename, FileMode.Create);
            twfs.Close();
            headdata = System.Text.Encoding.ASCII.GetBytes(head);
        }

        public void TW_Open()
        {
            twfsopen = new FileStream(filename, FileMode.OpenOrCreate);
            bw = new BinaryWriter(twfsopen);
            bw.Write(headdata);
            bw.Write(0);
        }

        public void TW_Close(int datanum)
        {
            int i;
            for (i = 0; i < enddata.Length; i++)
            {
                bw.Write(enddata[i]);
            }

            bw.Seek(headdata.Length, SeekOrigin.Begin);
            bw.Write(datanum);
            bw.Close();
            twfsopen.Close();
        }

    }
}
